Index: branches/proxy/src/lib/network/monitor/network_monitor.cc
===================================================================
--- branches/proxy/src/lib/network/monitor/network_monitor.cc	(revision 9347)
+++ branches/proxy/src/lib/network/monitor/network_monitor.cc	(revision 9347)
@@ -0,0 +1,269 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+### File Specific:
+   main-programmer: Patrick Boenzli
+*/
+
+#include "glgui.h"
+#include "shell_command.h"
+
+#include "network_stream.h"
+#include "debug.h"
+
+#include "proxy/proxy_settings.h"
+#include "shared_network_data.h"
+
+#include "network_monitor.h"
+#include "network_node.h"
+#include "peer_info.h"
+#include "network_stream.h"
+#include "netdefs.h"
+
+#include <vector>
+
+
+SHELL_COMMAND(showGUI, NetworkMonitor, showGUI);
+SHELL_COMMAND(hideGUI, NetworkMonitor, hideGUI);
+// SHELL_COMMAND(output, MappedWater, saveParams);
+
+
+
+/**
+ * starts a network monitor
+ */
+NetworkMonitor::NetworkMonitor(NetworkStream* networkStream)
+  : Synchronizeable()
+{
+  this->setClassID(CL_NETWORK_MONITOR, "NetworkMonitor");
+
+  this->networkStream = networkStream;
+  this->playerNumber = 0;
+  // create the localnode, init it and add it to the nodes list
+  this->localNode = new NetworkNode( this->networkStream->getPeerInfo());
+  this->addNode(this->localNode);
+
+  this->setSynchronized(false);
+
+  // read in the proxy server list, this is only the case for the master server
+  if( SharedNetworkData::getInstance()->isMasterServer())
+  {
+    // assuming that the config files are already read we get the proxy servers
+    std::vector<IPaddress*>* proxyList = ProxySettings::getInstance()->getProxyList();
+    std::vector<IPaddress*>::iterator it = proxyList->begin();
+    // create a peer info class and a network node class for each new proxy and add them to the passive list
+    for(; it < proxyList->end(); it++)
+    {
+      PeerInfo* peer = new PeerInfo();
+      peer->ip = *(*it);
+      peer->nodeType = NET_PROXY_SERVER_ACTIVE;
+      peer->userId = -1;
+
+      NetworkNode* node = new NetworkNode(peer);
+      this->addNode( node);
+      this->addActiveProxyServer( this->localNode, peer);
+    }
+  }
+}
+
+
+/**
+ * deconstructor
+ */
+NetworkMonitor::~NetworkMonitor()
+{
+  if( this->localNode)
+    delete this->localNode;
+}
+
+
+/**
+ * add the network node
+ * @param node to add
+ */
+void NetworkMonitor::addNetworkNode(NetworkNode* node)
+{
+  this->nodeList.push_back(node);
+}
+
+
+/**
+ * add the network node
+ * @param node to add
+ */
+void NetworkMonitor::removeNetworkNode(NetworkNode* node)
+{
+  std::list<NetworkNode*>::iterator it = this->nodeList.begin();
+  for(; it != this->nodeList.end(); it++)
+  {
+    if( *it == node)
+    {
+      this->nodeList.erase(it);
+      this->playerNumber--;
+      return;
+    }
+  }
+}
+
+/**
+ * tihs adds the new network node
+ * @param ip ip of the new node
+ */
+void NetworkMonitor::addNode(IP ip, int nodeType)
+{
+  PeerInfo* pInfo = new PeerInfo();
+  pInfo->nodeType = nodeType;
+  pInfo->ip = ip;
+
+  this->addNode( pInfo);
+}
+
+
+/**
+ * adds a network node to the local node
+ *  @param pInfo node information
+ */
+void NetworkMonitor::addNode(PeerInfo* pInfo)
+{
+  if( this->localNode == NULL)
+    return;
+
+  if( pInfo->isClient())
+    this->localNode->addClient(pInfo);
+  else if( pInfo->isProxyServer())
+  {
+    this->localNode->addActiveProxyServer(pInfo);
+    // create a new node, since a proxy can connect clients again
+    NetworkNode* node = new NetworkNode(pInfo);
+    this->nodeList.push_back(node);
+  }
+  else if( pInfo->isMasterServer())
+  {
+    this->localNode->addMasterServer(pInfo);
+  }
+}
+
+
+/**
+ * adds a network node to the local node
+ *  @param node node to add to
+ *  @param pInfo node information
+ */
+void NetworkMonitor::addNode(NetworkNode* node, PeerInfo* pInfo)
+{
+  if( node == NULL)
+    return;
+
+  if( pInfo->isClient())
+    node->addClient(pInfo);
+  else if( pInfo->isProxyServer())
+    node->addActiveProxyServer(pInfo);
+  else if( pInfo->isMasterServer())
+    node->addMasterServer(pInfo);
+}
+
+
+/**
+ * @returns the proxy server of the first choice
+ */
+PeerInfo* NetworkMonitor::getFirstChoiceProxy()
+{
+  // return the fist proxy in the list
+  return this->localNode->getActiveProxyServer(0);
+}
+
+
+/**
+ * @returns the proxy server of second choice
+ */
+PeerInfo* NetworkMonitor::getSecondChoiceProxy()
+{
+  // return the second server in the list
+  return this->localNode->getActiveProxyServer(1);
+}
+
+
+/**
+ * this displays the network monitor gui
+ */
+void NetworkMonitor::showGUI()
+{
+  if (this->box == NULL)
+  {
+    this->box = new OrxGui::GLGuiBox(OrxGui::Vertical);
+    {
+      OrxGui::GLGuiBox* waterColorBox = new OrxGui::GLGuiBox(OrxGui::Horizontal);
+      {
+        OrxGui::GLGuiText* waterColorText = new OrxGui::GLGuiText();
+        waterColorText->setText("NetworkMonitor");
+        waterColorBox->pack(waterColorText);
+      }
+      this->box->pack(waterColorBox);
+    }
+
+    this->box->showAll();
+    this->box->setAbsCoor2D(300, 40);
+    OrxGui::GLGuiHandler::getInstance()->activate();
+//     OrxGui::GLGuiHandler::getInstance()->activateCursor();
+  }
+}
+
+
+/**
+ * hides the network monitor gui again
+ */
+void NetworkMonitor::hideGUI()
+{
+  if( this->box == NULL)
+    return;
+
+  OrxGui::GLGuiHandler::getInstance()->deactivate();
+//   OrxGui::GLGuiHandler::getInstance()->deactivateCursor();
+
+  delete this->box;
+  this->box = NULL;
+}
+
+
+/**
+ * processes the network monitor data
+ */
+void NetworkMonitor::process()
+{
+  this->playerNumber = 0;
+  std::list<NetworkNode*>::iterator it = this->nodeList.begin();
+  for(; it != this->nodeList.end(); it++)
+  {
+    this->playerNumber += (*it)->getPlayerNumber();
+  }
+
+  // check if a proxy server has to activated
+
+//   this->debug();
+}
+
+/**
+ * prints out the debug informations
+ */
+void NetworkMonitor::debug()
+{
+  PRINT(0)("================================= Network Monitor::debug() =====\n");
+  PRINT(0)(" I am: %s\n", this->localNode->getPeerInfo()->getNodeTypeString().c_str());
+  PRINT(0)(" Total count of network connections: %i\n", this->playerNumber);
+
+  std::list<NetworkNode*>::iterator it = this->nodeList.begin();
+  for(; it != this->nodeList.end(); it++)
+  {
+    (*it)->debug(0);
+  }
+
+  PRINT(0)("================================================================\n");
+}
+
Index: branches/proxy/src/lib/network/monitor/network_monitor.h
===================================================================
--- branches/proxy/src/lib/network/monitor/network_monitor.h	(revision 9347)
+++ branches/proxy/src/lib/network/monitor/network_monitor.h	(revision 9347)
@@ -0,0 +1,89 @@
+/*!
+ * @file network_monitor.h
+ *  a class to monitor the network: throughput, network nodes
+ */
+
+#ifndef _NETWORK_MONITOR_H
+#define _NETWORK_MONITOR_H
+
+#include "base_object.h"
+#include "synchronizeable.h"
+#include "shared_network_data.h"
+#include "ip.h"
+
+#include "network_node.h"
+
+#include <list>
+
+class NetworkStream;
+class PeerInfo;
+
+
+namespace OrxGui { class GLGuiBox; };
+
+
+
+//!< a class that monitors the whole network. it tries to gather all informations its able to from the network
+class NetworkMonitor : public Synchronizeable
+{
+
+  public:
+    NetworkMonitor(NetworkStream* networkStream);
+    virtual ~NetworkMonitor();
+
+    /* client/masterserver/proxyserver addition/removal interface */
+    void addNetworkNode(NetworkNode* node);
+    void removeNetworkNode(NetworkNode* node);
+
+    void addNode(PeerInfo* pInfo);
+    void addNode(IP ip, int nodeType);
+    void addNode(NetworkNode* node) { this->nodeList.push_back(node); }
+    void addNode(NetworkNode* node, PeerInfo* pInfo);
+
+    /** adds to @param node a network node @param pInfo a new client */
+    inline void addClient(NetworkNode* node, PeerInfo* pInfo) { node->addClient(pInfo); }
+    /** adds to @param node a network node @param pInfo a new proxy server */
+    inline void addActiveProxyServer(NetworkNode* node, PeerInfo* pInfo) { node->addActiveProxyServer(pInfo); }
+    /** adds to @param node a network node @param pInfo a new proxy server */
+    inline void addPassiveProxyServer(NetworkNode* node, PeerInfo* pInfo) { node->addPassiveProxyServer(pInfo); }
+    /** adds to @param node a network node @param pInfo a new master server*/
+    inline void addMasterServer(NetworkNode* node, PeerInfo* pInfo) { node->addMasterServer(pInfo); }
+
+    inline void removeClient(NetworkNode* node, PeerInfo* pInfo) { node->removeClient(pInfo); }
+    inline void removeActiveProxyServer(NetworkNode* node, PeerInfo* pInfo) { node->removeActiveProxyServer(pInfo); }
+    inline void removePassiveProxyServer(NetworkNode* node, PeerInfo* pInfo) { node->removePassiveProxyServer(pInfo); }
+    inline void removeMasterServer(NetworkNode* node, PeerInfo* pInfo) { node->removeMasterServer(pInfo); }
+
+    /* slots admin and info interface */
+    /** @returns the total number of players in this game (including all proxy servers etc)*/
+    inline int getPlayerNumber() { return this->playerNumber; }
+
+    /** @returns true if there are still free network slots available */
+    inline bool gotFreeSlots() { return (this->localNode->getPlayerNumber() < SharedNetworkData::getInstance()->getMaxPlayer())?true:false; }
+    /** @param node node to be checked for slots @returns true if there are still free network slots available at this node */
+    inline bool gotFreeSlots(NetworkNode* node) { return (node->getPlayerNumber() < SharedNetworkData::getInstance()->getMaxPlayer())?true:false; }
+    PeerInfo* getFirstChoiceProxy();
+    PeerInfo* getSecondChoiceProxy();
+    /** @returns true if the next client should be reconnected to some other proxy server with more connections */
+    inline bool isReconnectNextClient() { return (this->localNode->getPlayerNumber() >= SharedNetworkData::getInstance()->getMaxPlayer())?true:false; }
+
+
+    void showGUI();
+    void hideGUI();
+
+    void process();
+    void debug();
+
+
+  private:
+    NetworkStream*               networkStream;              //!< reference to the one networkstream of the network
+    NetworkNode*                 localNode;                  //!< reference to the local node
+    std::list<NetworkNode*>      nodeList;                   //!< list of all network nodes
+
+    OrxGui::GLGuiBox*            box;
+
+    int                          playerNumber;                 //!< total number of players in the game
+};
+
+
+#endif
Index: branches/proxy/src/lib/network/monitor/network_node.cc
===================================================================
--- branches/proxy/src/lib/network/monitor/network_node.cc	(revision 9347)
+++ branches/proxy/src/lib/network/monitor/network_node.cc	(revision 9347)
@@ -0,0 +1,269 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+### File Specific:
+   main-programmer: Patrick Boenzli
+*/
+
+
+#include "network_node.h"
+
+#include "debug.h"
+
+
+/**
+ * constructor
+ */
+NetworkNode::NetworkNode(PeerInfo* pInfo)
+{
+  this->playerNumber = 0;
+  this->peerInfo = pInfo;
+}
+
+
+/**
+ * deconstructor
+ */
+NetworkNode::~NetworkNode()
+{}
+
+
+/**
+ * adds a client
+ */
+void NetworkNode::addClient(PeerInfo* node)
+{
+  this->clientList.push_back(node);
+  this->playerNumber++;
+}
+
+/**
+ * adds a proxy server
+ */
+void NetworkNode::addActiveProxyServer(PeerInfo* node)
+{
+  this->activeProxyServerList.push_back(node);
+  this->playerNumber++;
+}
+
+/**
+ * adds a proxy server
+ */
+void NetworkNode::addPassiveProxyServer(PeerInfo* node)
+{
+  this->passiveProxyServerList.push_back(node);
+}
+
+/**
+ * adds a master server
+ */
+void NetworkNode::addMasterServer(PeerInfo* node)
+{
+  this->masterServerList.push_back(node);
+  this->playerNumber++;
+}
+
+/**
+ * removes a client
+ */
+void NetworkNode::removeClient(PeerInfo* node)
+{
+  std::list<PeerInfo*>::iterator it = this->clientList.begin();
+  for(; it != this->clientList.end(); it++)
+  {
+    if( *it == node)
+    {
+      this->clientList.erase(it);
+      this->playerNumber--;
+      return;
+    }
+  }
+
+  PRINTF(2)("Could not remove client from the list, very strange...");
+}
+
+/**
+ * removes a proxy server
+ */
+void NetworkNode::removeActiveProxyServer(PeerInfo* node)
+{
+  std::list<PeerInfo*>::iterator it = this->activeProxyServerList.begin();
+  for(; it != this->activeProxyServerList.end(); it++)
+  {
+    if( *it == node)
+    {
+      this->activeProxyServerList.erase(it);
+      this->playerNumber--;
+      return;
+    }
+  }
+
+  PRINTF(2)("Could not remove proxy server from the list, very strange...");
+}
+
+/**
+ * removes a proxy server
+ */
+void NetworkNode::removePassiveProxyServer(PeerInfo* node)
+{
+  std::list<PeerInfo*>::iterator it = this->passiveProxyServerList.begin();
+  for(; it != this->passiveProxyServerList.end(); it++)
+  {
+    if( *it == node)
+    {
+      this->passiveProxyServerList.erase(it);
+      return;
+    }
+  }
+
+  PRINTF(2)("Could not remove proxy server from the list, very strange...");
+}
+
+/**
+ * removes a master server
+ */
+void NetworkNode::removeMasterServer(PeerInfo* node)
+{
+  std::list<PeerInfo*>::iterator it = this->masterServerList.begin();
+  for(; it != this->masterServerList.end(); it++)
+  {
+    if( *it == node)
+    {
+      this->masterServerList.erase(it);
+      this->playerNumber--;
+      return;
+    }
+  }
+
+  PRINTF(2)("Could not remove client from the list, very strange...");
+}
+
+
+/**
+ * @param index index to the client
+ * @return the client in the list or NULL if none
+ */
+PeerInfo* NetworkNode::getClient(int index)
+{
+  if( this->clientList.size() < index)
+    return NULL;
+
+  std::list<PeerInfo*>::iterator it = this->clientList.begin();
+  for(int i = 0; it != this->clientList.end(); it++, i++)
+  {
+  if( i == index)
+    return (*it);
+  }
+
+  return NULL;
+}
+
+
+/**
+ * @param index index to the client
+ * @return the active proxy server in the list or NULL if none
+ */
+PeerInfo* NetworkNode::getActiveProxyServer(int index)
+{
+  if( this->activeProxyServerList.size() < index)
+    return NULL;
+
+  std::list<PeerInfo*>::iterator it = this->activeProxyServerList.begin();
+  for(int i = 0; it != this->activeProxyServerList.end(); it++, i++)
+  {
+    if( i == index)
+      return (*it);
+  }
+
+  return NULL;
+}
+
+
+/**
+ * @param index index to the client
+ * @return the passive proxy server in the list or NULL if none
+ */
+PeerInfo* NetworkNode::getPassiveProxyServer(int index)
+{
+  if( this->passiveProxyServerList.size() < index)
+    return NULL;
+
+  std::list<PeerInfo*>::iterator it = this->passiveProxyServerList.begin();
+  for(int i = 0; it != this->passiveProxyServerList.end(); it++, i++)
+  {
+    if( i == index)
+      return (*it);
+  }
+
+  return NULL;
+}
+
+
+/**
+ * @param index index to the client
+ * @return the master server in the list or NULL if none
+ */
+PeerInfo* NetworkNode::getMasterServer(int index)
+{
+  if( this->masterServerList.size() < index)
+    return NULL;
+
+  std::list<PeerInfo*>::iterator it = this->masterServerList.begin();
+  for(int i = 0; it != this->masterServerList.end(); it++, i++)
+  {
+    if( i == index)
+      return (*it);
+  }
+
+  return NULL;
+}
+
+
+/**
+ * debug function
+ * @param depth: depth in the tree
+ */
+void NetworkNode::debug(int depth)
+{
+  PRINT(0)(" = %s\n", this->peerInfo->getNodeTypeString().c_str());
+
+  PRINT(0)("    master servers: %i\n", this->masterServerList.size());
+  std::list<PeerInfo*>::iterator it = this->masterServerList.begin();
+  for(; it != this->masterServerList.end(); it++)
+  {
+    IP* ip = &(*it)->ip;
+    PRINT(0)("     - ms, id: %i (%s)\n", (*it)->userId, ip->ipString().c_str());
+  }
+
+  PRINT(0)("    proxy servers active: %i\n", this->activeProxyServerList.size());
+  it = this->activeProxyServerList.begin();
+  for(; it != this->activeProxyServerList.end(); it++)
+  {
+    IP* ip = &(*it)->ip;
+    PRINT(0)("     - ps-a, id: %i (%s)\n", (*it)->userId, ip->ipString().c_str());
+  }
+
+  PRINT(0)("    proxy servers passive: %i\n", this->passiveProxyServerList.size());
+  it = this->passiveProxyServerList.begin();
+  for(; it != this->passiveProxyServerList.end(); it++)
+  {
+    IP* ip = &(*it)->ip;
+    PRINT(0)("     - ps-p, id: %i (%s)\n", (*it)->userId, ip->ipString().c_str());
+  }
+
+  PRINT(0)("    clients: %i\n", this->clientList.size());
+  it = this->clientList.begin();
+  for(; it != this->clientList.end(); it++)
+  {
+    IP* ip = &(*it)->ip;
+    PRINT(0)("     - client, id: %i (%s)\n", (*it)->userId, ip->ipString().c_str());
+  }
+}
+
Index: branches/proxy/src/lib/network/monitor/network_node.h
===================================================================
--- branches/proxy/src/lib/network/monitor/network_node.h	(revision 9347)
+++ branches/proxy/src/lib/network/monitor/network_node.h	(revision 9347)
@@ -0,0 +1,61 @@
+/*!
+ * @file network_node.h
+ *  a class representing a node in the network (this can be a MASTER_SERVER, PROXY_SERVER or a CLIENT
+ */
+
+#ifndef _NETWORK_NODE_H
+#define _NETWORK_NODE_H
+
+#include "base_object.h"
+#include "synchronizeable.h"
+#include "peer_info.h"
+
+#include <list>
+
+
+//!< a class representing a node in the network (this can be a MASTER_SERVER, PROXY_SERVER or a CLIENT
+class NetworkNode
+{
+  public:
+    NetworkNode(PeerInfo* pInfo);
+    ~NetworkNode();
+
+
+    void addClient(PeerInfo* node);
+    void addActiveProxyServer(PeerInfo* node);
+    void addPassiveProxyServer(PeerInfo* node);
+    void addMasterServer(PeerInfo* node);
+
+    void removeClient(PeerInfo* node);
+    void removeActiveProxyServer(PeerInfo* node);
+    void removePassiveProxyServer(PeerInfo* node);
+    void removeMasterServer(PeerInfo* node);
+
+    PeerInfo* getClient(int index);
+    PeerInfo* getActiveProxyServer(int index);
+    PeerInfo* getPassiveProxyServer(int index);
+    PeerInfo* getMasterServer(int index);
+
+    /** @returns the number of players */
+    inline int getPlayerNumber() { return this->playerNumber; }
+    /** @returns the node type of this node */
+    inline int getNodeType() { return this->peerInfo->nodeType; }
+    /** @returns the peer info of this node */
+    inline PeerInfo* getPeerInfo() { return this->peerInfo; }
+
+    void debug(int depth);
+
+
+  private:
+    int                          playerNumber;                 //!< localy direct connected player number
+    PeerInfo*                    peerInfo;                     //!< the peer informationa about this node
+
+    /* network nodes directly connected to this node */
+    std::list<PeerInfo*>         clientList;                   //!< list of all clients in the network
+    std::list<PeerInfo*>         activeProxyServerList;        //!< list of all proxy servers in the network
+    std::list<PeerInfo*>         passiveProxyServerList;       //!< list of all proxy servers in the network
+    std::list<PeerInfo*>         masterServerList;             //!< list of all master servers in the network (should be 1!! :D)
+
+};
+
+#endif /* _NETWORK_NODE_H */
Index: branches/proxy/src/lib/network/netdefs.h
===================================================================
--- branches/proxy/src/lib/network/netdefs.h	(revision 9346)
+++ branches/proxy/src/lib/network/netdefs.h	(revision 9347)
@@ -1,12 +1,28 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
 
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+### File Specific:
+   main-programmer: Christoph Renner rennerc@ee.ethz.ch
+   co-programmer:   Patrick Boenzli  boenzlip@orxonox.ethz.ch
+
+     June 2006: finishing work on the network stream for pps presentation (rennerc@ee.ethz.ch)
+     July 2006: some code rearangement and integration of the proxy server mechanism (boenzlip@ee.ethz.ch)
+*/
 
 /*!
  * @file network_manager.h
  *  Main interface for the network module. Manages all the modules
-
  */
 
 #ifndef _NETDEFS
 #define _NETDEFS
+
 
 #ifdef HAVE_SDL_NET_H
@@ -17,7 +33,18 @@
 
 
-#define MAX_CONNECTIONS 1000
+//!< maximal connectinons for the server
+#define NET_MAX_CONNECTIONS 100
 
+//!< the amount of slots used before a proxy server is activated
+#define NET_CONNECTION_SATURATION 0.75
+
+//!< network polling frequency
 #define NETWORK_FREQUENCY 66
+
+
+//!< orxonox protocol id
+#define _ORXONOX_ID        0xF91337A0
+//!< orxonox network version identifier
+#define _ORXONOX_VERSION   1
 
 
@@ -27,6 +54,11 @@
 //!< enum indicating the type of the node
 typedef enum {
-  NET_SERVER,
-  NET_CLIENT
+  NET_MASTER_SERVER,
+  NET_PROXY_SERVER_ACTIVE,
+  NET_PROXY_SERVER_PASSIVE,
+  NET_CLIENT,
+
+  NET_NR_TYPES
+
 } NodeType;
 
Index: branches/proxy/src/lib/network/network_game_manager.cc
===================================================================
--- branches/proxy/src/lib/network/network_game_manager.cc	(revision 9346)
+++ branches/proxy/src/lib/network/network_game_manager.cc	(revision 9347)
@@ -10,12 +10,13 @@
 
 ### File Specific:
-   main-programmer: Benjamin Wuest
-   co-programmer: ...
+   main-programmer: Christoph Renner rennerc@ee.ethz.ch
+   co-programmer:   Patrick Boenzli  boenzlip@orxonox.ethz.ch
+
+     June 2006: finishing work on the network stream for pps presentation (rennerc@ee.ethz.ch)
+     July 2006: some code rearangement and integration of the proxy server mechanism (boenzlip@ee.ethz.ch)
 */
 
 
-/* this is for debug output. It just says, that all calls to PRINT() belong to the DEBUG_MODULE_NETWORK module
-   For more information refere to https://www.orxonox.net/cgi-bin/trac.cgi/wiki/DebugOutput
-*/
+
 #define DEBUG_MODULE_NETWORK
 
@@ -45,5 +46,4 @@
 
 
-/* using namespace std is default, this needs to be here */
 using namespace std;
 
@@ -62,9 +62,9 @@
 
   this->setSynchronized(true);
-  
+
   MessageManager::getInstance()->registerMessageHandler( MSGID_DELETESYNCHRONIZEABLE, delSynchronizeableHandler, NULL );
   MessageManager::getInstance()->registerMessageHandler( MSGID_PREFEREDTEAM, preferedTeamHandler, NULL );
   MessageManager::getInstance()->registerMessageHandler( MSGID_CHATMESSAGE, chatMessageHandler, NULL );
-  
+
   this->gameState = 0;
   registerVar( new SynchronizeableInt( &gameState, &gameState, "gameState" ) );
@@ -77,7 +77,7 @@
 {
   delete MessageManager::getInstance();
-  
+
   PlayerStats::deleteAllPlayerStats();
-  
+
   NetworkGameManager::singletonRef = NULL;
 }
@@ -86,15 +86,15 @@
 /**
  * insert new player into game
- * @param userId 
- * @return 
+ * @param userId
+ * @return
  */
 bool NetworkGameManager::signalNewPlayer( int userId )
 {
-  assert( SharedNetworkData::getInstance()->isGameServer() );
+  assert( SharedNetworkData::getInstance()->isMasterServer() );
   assert( State::getGameRules() );
   assert( State::getGameRules()->isA( CL_NETWORK_GAME_RULES ) );
-  
+
   NetworkGameRules & rules = *(dynamic_cast<NetworkGameRules*>(State::getGameRules()));
-  
+
   int team = rules.getTeamForNewUser();
   ClassID playableClassId = rules.getPlayableClassId( userId, team );
@@ -102,36 +102,36 @@
   std::string playableTexture = rules.getPlayableModelFileName( userId, team, playableClassId );
   float       playableScale = rules.getPlayableScale( userId, team, playableClassId );
-  
+
   BaseObject * bo = Factory::fabricate( playableClassId );
-  
+
   assert( bo != NULL );
   assert( bo->isA( CL_PLAYABLE ) );
-  
+
   Playable & playable = *(dynamic_cast<Playable*>(bo));
-  
+
   playable.loadMD2Texture( playableTexture );
-  
+
   playable.loadModel( playableModel, 100.0f );
   playable.setOwner( userId );
   playable.setUniqueID( SharedNetworkData::getInstance()->getNewUniqueID() );
   playable.setSynchronized( true );
-  
+
   PlayerStats * stats = rules.getNewPlayerStats( userId );
-  
+
   stats->setUniqueID( SharedNetworkData::getInstance()->getNewUniqueID() );
   stats->setSynchronized( true );
   stats->setOwner( SharedNetworkData::getInstance()->getHostID() );
-  
+
   stats->setTeamId( team );
   stats->setPlayableClassId( playableClassId );
   stats->setPlayableUniqueId( playable.getUniqueID() );
   stats->setModelFileName( playableModel );
-  
+
   if ( userId == 0 )
     stats->setNickName( Preferences::getInstance()->getString( "multiplayer", "nickname", "Server" ) );
-  
+
   if ( rules.isA( CL_MULTIPLAYER_TEAM_DEATHMATCH ) )
     dynamic_cast<MultiplayerTeamDeathmatch*>(&rules)->respawnPlayable( &playable, team, 0.0f );
-  
+
   return true;
 }
@@ -140,6 +140,6 @@
 /**
  * remove player from game
- * @param userID 
- * @return 
+ * @param userID
+ * @return
  */
 bool NetworkGameManager::signalLeftPlayer(int userID)
@@ -151,5 +151,5 @@
     delete PlayerStats::getStats( userID );
   }
-  
+
   return true;
 }
@@ -159,22 +159,22 @@
 /**
  * handler for remove synchronizeable messages
- * @param messageId 
- * @param data 
- * @param dataLength 
- * @param someData 
- * @param userId 
+ * @param messageId
+ * @param data
+ * @param dataLength
+ * @param someData
+ * @param userId
  * @return true on successfull handling else handler will be called again
  */
 bool NetworkGameManager::delSynchronizeableHandler( MessageId messageId, byte * data, int dataLength, void * someData, int userId )
 {
-  if ( getInstance()->isServer() )
+  if ( SharedNetworkData::getInstance()->isMasterServer() )
   {
     PRINTF(2)("Recieved DeleteSynchronizeable message from client %d!\n", userId);
     return true;
   }
-  
+
   int uniqueId = 0;
   int len = Converter::byteArrayToInt( data, &uniqueId );
-  
+
   if ( len != dataLength )
   {
@@ -182,7 +182,7 @@
     return true;
   }
-  
+
   const std::list<BaseObject*> * list = ClassList::getList( CL_SYNCHRONIZEABLE );
-  
+
   for ( std::list<BaseObject*>::const_iterator it = list->begin(); it != list->end(); it++ )
   {
@@ -194,10 +194,10 @@
         return true;
       }
-      
+
       delete dynamic_cast<Synchronizeable*>(*it);
       return true;
     }
   }
-  
+
   return true;
 }
@@ -210,5 +210,5 @@
 {
   byte buf[INTSIZE];
-  
+
   assert( Converter::intToByteArray( uniqueId, buf, INTSIZE ) == INTSIZE );
 
@@ -220,18 +220,18 @@
 /**
  * handler for MSGID_PREFEREDTEAM message
- * @param messageId 
- * @param data 
- * @param dataLength 
- * @param someData 
- * @param userId 
- * @return 
+ * @param messageId
+ * @param data
+ * @param dataLength
+ * @param someData
+ * @param userId
+ * @return
  */
 bool NetworkGameManager::preferedTeamHandler( MessageId messageId, byte * data, int dataLength, void * someData, int userId )
 {
-  assert( NetworkGameManager::getInstance()->isServer() );
-  
+  assert( SharedNetworkData::getInstance()->isMasterServer() );
+
   int teamId = 0;
   int len = Converter::byteArrayToInt( data, &teamId );
-  
+
   if ( len != dataLength )
   {
@@ -239,7 +239,7 @@
     return true;
   }
-  
+
   NetworkGameManager::getInstance()->setPreferedTeam( userId, teamId );
-  
+
   return true;
 }
@@ -249,7 +249,7 @@
   if ( !PlayerStats::getStats( userId ) )
     return;
-  
+
   PlayerStats & stats = *(PlayerStats::getStats( userId ));
-  
+
   stats.setPreferedTeamId( teamId );
 }
@@ -257,16 +257,16 @@
 /**
  * set prefered team for this host
- * @param teamId 
+ * @param teamId
  */
 void NetworkGameManager::prefereTeam( int teamId )
 {
-  if ( isServer() )
+  if ( SharedNetworkData::getInstance()->isMasterServer() )
     setPreferedTeam( SharedNetworkData::getInstance()->getHostID(), teamId );
   else
   {
     byte buf[INTSIZE];
-    
+
     assert( Converter::intToByteArray( teamId, buf, INTSIZE) == INTSIZE );
-    
+
     MessageManager::getInstance()->sendMessage( MSGID_PREFEREDTEAM, buf, INTSIZE, RT_USER, 0, MP_HIGHBANDWIDTH );
   }
@@ -285,7 +285,7 @@
     {
       const std::list<BaseObject*> * list = ClassList::getList( CL_PLAYABLE );
-       
+
       if ( list && std::find( list->begin(), list->end(), *it ) != list->end() )
-      {      
+      {
         PRINTF(0)("Delete unused playable: %s owner: %d\n", (*it)->getClassName(), (*it)->getOwner() );
         std::list<Playable*>::iterator delit = it;
@@ -305,21 +305,21 @@
 {
   PRINTF(0)("NetworkGameManager::chatMessageHandler %d %d\n", userId, SharedNetworkData::getInstance()->getHostID() );
-  if ( NetworkGameManager::getInstance()->isServer() && userId !=  SharedNetworkData::getInstance()->getHostID() )
+  if ( SharedNetworkData::getInstance()->isMasterServer() && userId !=  SharedNetworkData::getInstance()->getHostID() )
   {
     MessageManager::getInstance()->sendMessage( messageId, data, dataLength, RT_ALL_NOT_ME, 0, MP_HIGHBANDWIDTH );
   }
-  
+
   assert( State::getGameRules() );
   assert( State::getGameRules()->isA( CL_NETWORK_GAME_RULES ) );
-  
+
   NetworkGameRules & rules = *(dynamic_cast<NetworkGameRules*>(State::getGameRules()));
-  
+
   if ( dataLength < 3*INTSIZE )
   {
     PRINTF(2)("got too small chatmessage from client %d\n", userId);
-    
+
     return true;
   }
-  
+
   int messageType = 0;
   Converter::byteArrayToInt( data, &messageType );
@@ -328,5 +328,5 @@
   std::string message;
   Converter::byteArrayToString( data+2*INTSIZE, message, dataLength-2*INTSIZE );
-  
+
   rules.handleChatMessage( senderUserId, message, messageType );
 
@@ -346,11 +346,11 @@
   assert( Converter::intToByteArray( SharedNetworkData::getInstance()->getHostID(), buf+INTSIZE, INTSIZE ) == INTSIZE );
   assert( Converter::stringToByteArray(message, buf+2*INTSIZE, message.length()+INTSIZE) == message.length()+INTSIZE );
-  
-  if ( this->isServer() )
+
+  if ( SharedNetworkData::getInstance()->isMasterServer() )
     MessageManager::getInstance()->sendMessage( MSGID_CHATMESSAGE, buf, message.length()+3*INTSIZE, RT_ALL_ME, 0, MP_HIGHBANDWIDTH );
   else
     MessageManager::getInstance()->sendMessage( MSGID_CHATMESSAGE, buf, message.length()+3*INTSIZE, RT_ALL_NOT_ME, 0, MP_HIGHBANDWIDTH );
 
-  
+
   delete [] buf;
 }
